package com.tourism.webadmin.back.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.tourism.webadmin.back.dao.ChinaAreaMapper;
import com.tourism.webadmin.back.model.ChinaArea;
import com.tourism.webadmin.back.service.ChinaAreaService;
import com.tourism.webadmin.config.DataSourceType;
import com.tourism.common.core.annotation.MyDataSource;
import com.tourism.common.core.base.dao.BaseDaoMapper;
import com.tourism.common.core.object.MyRelationParam;
import com.tourism.common.core.base.service.BaseService;
import com.tourism.common.sequence.wrapper.IdGeneratorWrapper;
import com.github.pagehelper.Page;
import lombok.extern.slf4j.Slf4j;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * 中国行政区划信息数据操作服务类。
 *
 * @author 吃饭睡觉
 * @date 2024-09-06
 */
@Slf4j
@MyDataSource(DataSourceType.MAIN)
@Service("chinaAreaService")
public class ChinaAreaServiceImpl extends BaseService<ChinaArea, Long> implements ChinaAreaService {

    @Autowired
    private IdGeneratorWrapper idGenerator;
    @Autowired
    private ChinaAreaMapper chinaAreaMapper;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<ChinaArea> mapper() {
        return chinaAreaMapper;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public ChinaArea saveNew(ChinaArea chinaArea) {
        chinaAreaMapper.insert(this.buildDefaultValue(chinaArea));
        return chinaArea;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<ChinaArea> chinaAreaList) {
        if (CollUtil.isNotEmpty(chinaAreaList)) {
            chinaAreaList.forEach(this::buildDefaultValue);
            chinaAreaMapper.insertList(chinaAreaList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(ChinaArea chinaArea, ChinaArea originalChinaArea) {
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<ChinaArea> uw = this.createUpdateQueryForNullValue(chinaArea, chinaArea.getCode());
        return chinaAreaMapper.update(chinaArea, uw) == 1;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long code) {
        return chinaAreaMapper.deleteById(code) == 1;
    }

    @Override
    public List<ChinaArea> getChinaAreaList(ChinaArea filter, String orderBy) {
        return chinaAreaMapper.getChinaAreaList(filter, orderBy);
    }

    @Override
    public List<ChinaArea> getChinaAreaListWithRelation(ChinaArea filter, String orderBy) {
        List<ChinaArea> resultList = chinaAreaMapper.getChinaAreaList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    @Override
    public boolean hasChildren(Long code) {
        ChinaArea filter = new ChinaArea();
        filter.setCityCode(code);
        return getCountByFilter(filter) > 0;
    }

    private ChinaArea buildDefaultValue(ChinaArea chinaArea) {
        if (chinaArea.getCode() == null) {
            chinaArea.setCode(idGenerator.nextLongId());
        }
        return chinaArea;
    }
}
